SyntaxElementMorph subclass: #ObjectElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:44'!
asSmalltalk 

	^name ifNil: ['undefined']! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	(owner class == PaletteElementMorph)
		ifTrue: [m add: 'remove' action: #removeFromPalette ]
		ifFalse: [
		 	self isRenameable ifTrue: [
				m add: 'rename...' action: #editLabel ]].
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.

	^m! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:15'!
editLabel
	|ans|

	ans _ FillInTheBlank request: 'rename:' initialAnswer: label contents.
	(ans size > 0) ifTrue: [self label: ans]! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 11:14'!
initialize
	super initialize.
	color _ Color blue darker.
! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:26'!
isRenameable
	| editor method |
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor isNil ifTrue: [^true].
	method _ (self ownerThatIsA: MethodElementMorph).
	method ifNotNil: [
		^(self ownerThatIsA: StepHolderElementMorph) isNil].
	^false
! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:13'!
label
	^label contents! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:28'!
label: aString

	super label: aString.

	(owner isKindOf: PaletteElementMorph)
		ifTrue: [^self color: owner ownerColor twiceDarker ].

	(#('self' 'super' 'nil' 'true' 'false' 'thisContext') includes: aString)
		ifTrue: [^self color: Color red darker].

	aString first isUppercase
		ifTrue: [
			(Smalltalk classNames includes: aString asSymbol)
				ifTrue: [^self color: Color magenta darker darker].
			(Smalltalk keys includes: aString asSymbol)
				ifTrue: [^self color: Color magenta twiceDarker darker].

			^self color: Color blue twiceDarker ].

	self color: Color blue darker..

! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 15:14'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:17'!
removeFromPalette
	owner removeVariable: self! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:50'!
representsNil
	^name = 'nil'! !
