BooleanArgMorph subclass: #PredicateArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!PredicateArgMorph methodsFor: 'drawing' stamp: 'jens 7/21/2010 19:29'!
drawOn: aCanvas 

	| h s v darkerC lighterC right topY bottomY xInset c |
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	darkerC _ Color h: h s: (s - 0.3) v: (v - 0.3).
	lighterC _ Color h: h s: (s - 0.2) v: (v + 0.2).

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	[topY >= 0] whileTrue: [
		self drawHLineFrom: xInset to: (xInset + 2) y: topY color: darkerC on: aCanvas.
		c _ (topY <= 1) ifTrue: [darkerC] ifFalse: [color].
		self drawHLineFrom: xInset + 2 to: right - (xInset + 1) y: topY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 1)) to: (right - xInset) y: topY color: darkerC on: aCanvas.

		self drawHLineFrom: xInset to: (xInset + 1) y: bottomY color: lighterC on: aCanvas.
		c _ (bottomY >= (self height - 2)) ifTrue: [lighterC] ifFalse: [color].
		self drawHLineFrom: xInset + 1 to: right - (xInset + 1) y: bottomY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 2)) to: (right - xInset) y: bottomY color: lighterC on: aCanvas.

		xInset _ xInset + 1.	
		bottomY _ bottomY + 1.
		topY _ topY - 1].

! !
